Attribute VB_Name = "Database_building_routines"
Attribute VB_Description = "Database building proceedures"
Public Password_Confirmed As String

Public Sub Create_libra_database(Libra_path As String)
    On Local Error GoTo error_solver
    Set MyWorkspace = DBEngine.Workspaces(0)
    
    If Dir(Libra_path) <> "" Then
        Kill Libra_path
    End If
    
    Set Libra = MyWorkspace.CreateDatabase _
                (Libra_path, dbLangGeneral, dbEncrypt)
    On Local Error GoTo 0
    
    Create_setup_table
    Create_books_table
    Create_deregistered_books_table
    Create_subscriber_table
    Create_terminated_subsc_table
    Create_books_borrowed_table
    Create_books_requested_table
    
    Set Query = Libra.CreateQueryDef("Query Obj")
    Set Query = Libra.CreateQueryDef("Direct SQL Query")
    Set Query = Libra.CreateQueryDef("Report Query Object")
    
Exit Sub
    
error_solver:
        If Err.Number = 3204 Then
            Kill Get_ini_data("Libra_db_path")
        Else
            Err.Raise Err.Number
       End If
    Resume

End Sub

Public Sub Create_subscriber_table()
    
    
    'Create Subscriber table
    
    Set Subscriber_table = Libra.CreateTableDef("Subscriber table")
        
    Set SubscriberID = Subscriber_table.CreateField("Subscriber ID", dbText, 8)
    Set National_ID = Subscriber_table.CreateField("National ID", dbText, 20)
    Set Date_reg = Subscriber_table.CreateField("Registered on", dbDate)
    Set Surname = Subscriber_table.CreateField("Surname", dbText, 15)
    Set Initials = Subscriber_table.CreateField("Initials", dbText, 4)
    Set Home_address = Subscriber_table.CreateField("Home address", dbText, 60)
    Set Home_phone_no = Subscriber_table.CreateField("Home Phone Number", dbText, 12)
    Set Contact_address = Subscriber_table.CreateField("Contact Address", dbText, 60)
    Set Contact_phone_no = Subscriber_table.CreateField("Contact Phone Number", dbText, 12)
    Set Expiry_date = Subscriber_table.CreateField("Expiry date", dbDate)
    Set Borrowing_limit = Subscriber_table.CreateField("Borrowing limit", dbInteger)
    Set Title_field = Subscriber_table.CreateField("Subscriber title", dbText, 4)
    Set Borrowing_fee = Subscriber_table.CreateField("Borrowing Fee", dbInteger)
    Set Loan_period = Subscriber_table.CreateField("Loan Period", dbText, 4)
    Set Remark_field = Subscriber_table.CreateField("Remark", dbText, 30)
    
    
    
    Subscriber_table.Fields.Append SubscriberID
    Subscriber_table.Fields.Append National_ID
    Subscriber_table.Fields.Append Date_reg
    Subscriber_table.Fields.Append Surname
    Subscriber_table.Fields.Append Initials
    Subscriber_table.Fields.Append Home_address
    Subscriber_table.Fields.Append Home_phone_no
    Subscriber_table.Fields.Append Contact_address
    Subscriber_table.Fields.Append Contact_phone_no
    Subscriber_table.Fields.Append Expiry_date
    Subscriber_table.Fields.Append Borrowing_limit
    Subscriber_table.Fields.Append Title_field
    Subscriber_table.Fields.Append Borrowing_fee
    Subscriber_table.Fields.Append Loan_period
    Subscriber_table.Fields.Append Remark_field
   
    Libra.TableDefs.Append Subscriber_table
    
    Set SubscriberID_index = Subscriber_table.CreateIndex("SubscriberID index")
    Set SubscriberID = SubscriberID_index.CreateField("Subscriber ID")
    SubscriberID_index.Fields.Append SubscriberID
    Subscriber_table.Indexes.Append SubscriberID_index
    
    Set Name_index = Subscriber_table.CreateIndex("Name index")
    Set Surname = Name_index.CreateField("Surname")
    Set Initials = Name_index.CreateField("Initials")
    Set Title_field = Name_index.CreateField("subscriber title")
    Name_index.Fields.Append Surname
    Name_index.Fields.Append Initials
    Name_index.Fields.Append Title_field
    Subscriber_table.Indexes.Append Name_index
    
    Set Registered_on_index = Subscriber_table.CreateIndex("Registered on index")
    Set Date_reg = Registered_on_index.CreateField("Registered on")
    Set SubscriberID = Registered_on_index.CreateField("Subscriber ID")
    Registered_on_index.Fields.Append Date_reg
    Registered_on_index.Fields.Append SubscriberID
    Subscriber_table.Indexes.Append Registered_on_index
    
    Set Expiry_date_index = Subscriber_table.CreateIndex("Expires on index")
    Set Expiry_date = Expiry_date_index.CreateField("expiry date")
    Set SubscriberID = Expiry_date_index.CreateField("Subscriber ID")
    Expiry_date_index.Fields.Append Expiry_date
    Expiry_date_index.Fields.Append SubscriberID
    Subscriber_table.Indexes.Append Expiry_date_index
    
    
    
    
    

End Sub

Public Sub Create_terminated_subsc_table()
    
    Set Terminated_subscriptions_tbl = Libra.CreateTableDef("terminated subscriptions table")
    
    
    
    Set Deregistered = Terminated_subscriptions_tbl.CreateField("Deregistered", dbDate)
    Set Cancellation_remark = Terminated_subscriptions_tbl.CreateField("cancellation remark", dbText, 30)
    Set Reason = Terminated_subscriptions_tbl.CreateField("Reason", dbText, 30)
        
    Set SubscriberID = Terminated_subscriptions_tbl.CreateField("Subscriber ID", dbText, 8)
    Set National_ID = Terminated_subscriptions_tbl.CreateField("National ID", dbText, 20)
    Set Date_reg = Terminated_subscriptions_tbl.CreateField("Registered on", dbDate)
    Set Surname = Terminated_subscriptions_tbl.CreateField("Surname", dbText, 15)
    Set Initials = Terminated_subscriptions_tbl.CreateField("Initials", dbText, 4)
    Set Home_address = Terminated_subscriptions_tbl.CreateField("Home address", dbText, 60)
    Set Home_phone_no = Terminated_subscriptions_tbl.CreateField("Home Phone Number", dbText, 12)
    Set Contact_address = Terminated_subscriptions_tbl.CreateField("Contact Address", dbText, 60)
    Set Contact_phone_no = Terminated_subscriptions_tbl.CreateField("Contact Phone Number", dbText, 12)
    Set Expiry_date = Terminated_subscriptions_tbl.CreateField("Expiry date", dbDate)
    Set Borrowing_limit = Terminated_subscriptions_tbl.CreateField("Borrowing limit", dbInteger)
    Set Title_field = Terminated_subscriptions_tbl.CreateField("Subscriber title", dbText, 4)
    Set Borrowing_fee = Terminated_subscriptions_tbl.CreateField("Borrowing Fee", dbInteger)
    Set Loan_period = Terminated_subscriptions_tbl.CreateField("Loan Period", dbText, 4)
    Set Remark_field = Terminated_subscriptions_tbl.CreateField("Remark", dbText, 30)
    
    
    
    Terminated_subscriptions_tbl.Fields.Append SubscriberID
    Terminated_subscriptions_tbl.Fields.Append National_ID
    Terminated_subscriptions_tbl.Fields.Append Date_reg
    Terminated_subscriptions_tbl.Fields.Append Surname
    Terminated_subscriptions_tbl.Fields.Append Initials
    Terminated_subscriptions_tbl.Fields.Append Home_address
    Terminated_subscriptions_tbl.Fields.Append Home_phone_no
    Terminated_subscriptions_tbl.Fields.Append Contact_address
    Terminated_subscriptions_tbl.Fields.Append Contact_phone_no
    Terminated_subscriptions_tbl.Fields.Append Expiry_date
    Terminated_subscriptions_tbl.Fields.Append Borrowing_limit
    Terminated_subscriptions_tbl.Fields.Append Title_field
    Terminated_subscriptions_tbl.Fields.Append Borrowing_fee
    Terminated_subscriptions_tbl.Fields.Append Loan_period
    Terminated_subscriptions_tbl.Fields.Append Remark_field
    
    Terminated_subscriptions_tbl.Fields.Append Deregistered
    Terminated_subscriptions_tbl.Fields.Append Cancellation_remark
    Terminated_subscriptions_tbl.Fields.Append Reason
    
    Libra.TableDefs.Append Terminated_subscriptions_tbl
    
    Set Terminated_SubscriberID_index = Terminated_subscriptions_tbl.CreateIndex("SubscriberID index")
    Set SubscriberID = Terminated_SubscriberID_index.CreateField("Subscriber ID")
    Terminated_SubscriberID_index.Fields.Append SubscriberID
    Terminated_subscriptions_tbl.Indexes.Append Terminated_SubscriberID_index
        
    Set Name_index = Terminated_subscriptions_tbl.CreateIndex("Name index")
    Set Surname = Name_index.CreateField("Surname")
    Set Initials = Name_index.CreateField("Initials")
    Set Title_field = Name_index.CreateField("subscriber title")
    Name_index.Fields.Append Surname
    Name_index.Fields.Append Initials
    Name_index.Fields.Append Title_field
    Terminated_subscriptions_tbl.Indexes.Append Name_index
    
    Set Registered_on_index = Terminated_subscriptions_tbl.CreateIndex("Registered on index")
    Set Date_reg = Registered_on_index.CreateField("Registered on")
    Set SubscriberID = Registered_on_index.CreateField("Subscriber ID")
    Registered_on_index.Fields.Append Date_reg
    Registered_on_index.Fields.Append SubscriberID
    Terminated_subscriptions_tbl.Indexes.Append Registered_on_index
    
    Set Expiry_date_index = Terminated_subscriptions_tbl.CreateIndex("Expires on index")
    Set Expiry_date = Expiry_date_index.CreateField("expiry date")
    Set SubscriberID = Expiry_date_index.CreateField("Subscriber ID")
    Expiry_date_index.Fields.Append Expiry_date
    Expiry_date_index.Fields.Append SubscriberID
    Terminated_subscriptions_tbl.Indexes.Append Expiry_date_index
    
    Set Deregistered_on_index = Terminated_subscriptions_tbl.CreateIndex("Deregistered on index")
    Set Deregistered = Deregistered_on_index.CreateField("Deregistered")
    Set SubscriberID = Deregistered_on_index.CreateField("Subscriber ID")
    Deregistered_on_index.Fields.Append Deregistered
    Deregistered_on_index.Fields.Append SubscriberID
    Terminated_subscriptions_tbl.Indexes.Append Deregistered_on_index
    
    Set Reason_index = Terminated_subscriptions_tbl.CreateIndex("Reason index")
    Set Reason = Reason_index.CreateField("reason")
    Set SubscriberID = Reason_index.CreateField("Subscriber ID")
    Reason_index.Fields.Append Reason
    Reason_index.Fields.Append SubscriberID
    Terminated_subscriptions_tbl.Indexes.Append Reason_index
    
    
    
    
    
End Sub

Public Sub Create_books_table()
    
    Set Books_table = Libra.CreateTableDef("Books Table")
    
    Set Bk_number = Books_table.CreateField("Book Number", dbLong)
    Set Date_reg = Books_table.CreateField("Date registered", dbDate)
    Set Title_field = Books_table.CreateField("Book Title", dbText, 25)
    Set Author_field = Books_table.CreateField("Book author", dbText, 20)
    Set Borrowing_fee = Books_table.CreateField("Borrowing fee", dbInteger)
    Set Loan_period = Books_table.CreateField("Loan period", dbText, 4)
    Set Class_field = Books_table.CreateField("Class", dbText, 10)
    Set Dewey_field = Books_table.CreateField("Dewey", dbText, 15)
    Set ISBN_field = Books_table.CreateField("ISBN", dbText, 20)
    Set Loanable = Books_table.CreateField("Loanable", dbBoolean)
    Set Publisher_field = Books_table.CreateField("Publisher", dbText, 25)
    Set Supplier_field = Books_table.CreateField("Supplier", dbText, 20)
    Set Remark_field = Books_table.CreateField("Remark", dbText, 30)
    
    Books_table.Fields.Append Bk_number
    Books_table.Fields.Append Date_reg
    Books_table.Fields.Append Title_field
    Books_table.Fields.Append Author_field
    Books_table.Fields.Append Borrowing_fee
    Books_table.Fields.Append Loan_period
    Books_table.Fields.Append Loanable
    Books_table.Fields.Append Class_field
    Books_table.Fields.Append Dewey_field
    Books_table.Fields.Append ISBN_field
    Books_table.Fields.Append Publisher_field
    Books_table.Fields.Append Supplier_field
    Books_table.Fields.Append Remark_field
    
    Libra.TableDefs.Append Books_table
    
    
    Set Book_number_index = Books_table.CreateIndex("Book number index")
    Set Bk_number = Book_number_index.CreateField("Book number")
    Book_number_index.Fields.Append Bk_number
    Books_table.Indexes.Append Book_number_index
    
    Set Author_index = Books_table.CreateIndex("Author index")
    Set Author_field = Author_index.CreateField("Book Author")
    Set Title_field = Author_index.CreateField("Book title")
    Set Bk_number = Author_index.CreateField("Book number")
    Author_index.Fields.Append Author_field
    Author_index.Fields.Append Title_field
    Author_index.Fields.Append Bk_number
    Books_table.Indexes.Append Author_index
    
        
    Set Title_index = Books_table.CreateIndex("Title index")
    Set Title_field = Title_index.CreateField("Book Title")
    Set Author_field = Title_index.CreateField("Book Author")
    Set Bk_number = Title_index.CreateField("Book number")
    Title_index.Fields.Append Title_field
    Title_index.Fields.Append Author_field
    Title_index.Fields.Append Bk_number
    Books_table.Indexes.Append Title_index
     
    Set Registered_on_index = Books_table.CreateIndex("Registered on index")
    Set Date_reg = Registered_on_index.CreateField("Date registered")
    Set Bk_number = Registered_on_index.CreateField("Book number")
    Registered_on_index.Fields.Append Date_reg
    Registered_on_index.Fields.Append Bk_number
    Books_table.Indexes.Append Registered_on_index
    
    Set Dewey_index = Books_table.CreateIndex("Dewey index")
    Set Dewey_field = Dewey_index.CreateField("Dewey")
    Set Bk_number = Dewey_index.CreateField("Book number")
    Dewey_index.Fields.Append Dewey_field
    Dewey_index.Fields.Append Bk_number
    Books_table.Indexes.Append Dewey_index
    
    Set Class_index = Books_table.CreateIndex("Class index")
    Set Class_field = Class_index.CreateField("class")
    Set Bk_number = Class_index.CreateField("Book number")
    Class_index.Fields.Append Class_field
    Class_index.Fields.Append Bk_number
    Books_table.Indexes.Append Class_index
    
End Sub

Public Sub Create_deregistered_books_table()
    Set Books_table = Libra.CreateTableDef("Deregistered Books")
    
    'additions
    Set Deregistered = Books_table.CreateField("Deregistered", dbDate)
    Set Cancellation_remark = Books_table.CreateField("cancellation remark", dbText, 30)
    Set Reason = Books_table.CreateField("Reason", dbText, 30)
    
    'taken from books table
    Set Bk_number = Books_table.CreateField("Book Number", dbLong)
    Set Date_reg = Books_table.CreateField("Date registered", dbDate)
    Set Title_field = Books_table.CreateField("Book Title", dbText, 25)
    Set Author_field = Books_table.CreateField("Book author", dbText, 20)
    Set Borrowing_fee = Books_table.CreateField("Borrowing fee", dbInteger)
    Set Loan_period = Books_table.CreateField("Loan period", dbText, 4)
    Set Loanable = Books_table.CreateField("Loanable", dbBoolean)
    Set Publisher_field = Books_table.CreateField("Publisher", dbText, 25)
    Set Supplier_field = Books_table.CreateField("Supplier", dbText, 20)
    Set Dewey_field = Books_table.CreateField("Dewey", dbText, 15)
    Set Class_field = Books_table.CreateField("Class", dbText, 10)
    Set ISBN_field = Books_table.CreateField("ISBN", dbText, 20)
    Set Remark_field = Books_table.CreateField("Remark", dbText, 30)
    
    Books_table.Fields.Append Date_reg
    Books_table.Fields.Append Deregistered
    Books_table.Fields.Append Reason
    
    Books_table.Fields.Append Bk_number
    Books_table.Fields.Append Title_field
    Books_table.Fields.Append Author_field
    Books_table.Fields.Append Borrowing_fee
    Books_table.Fields.Append Loan_period
    Books_table.Fields.Append Loanable
    Books_table.Fields.Append Dewey_field
    Books_table.Fields.Append Class_field
    Books_table.Fields.Append ISBN_field
    Books_table.Fields.Append Publisher_field
    Books_table.Fields.Append Supplier_field
    Books_table.Fields.Append Remark_field
    Books_table.Fields.Append Cancellation_remark
    
    Libra.TableDefs.Append Books_table
    
    Set Book_number_index = Books_table.CreateIndex("Book number index")
    Set Bk_number = Book_number_index.CreateField("Book number")
    Book_number_index.Fields.Append Bk_number
    Books_table.Indexes.Append Book_number_index
    
    Set Author_index = Books_table.CreateIndex("Author index")
    Set Author_field = Author_index.CreateField("Book Author")
    Set Title_field = Author_index.CreateField("Book title")
    Set Bk_number = Author_index.CreateField("Book number")
    Author_index.Fields.Append Author_field
    Author_index.Fields.Append Title_field
    Author_index.Fields.Append Bk_number
    Books_table.Indexes.Append Author_index
    
        
    Set Title_index = Books_table.CreateIndex("Title index")
    Set Title_field = Title_index.CreateField("Book Title")
    Set Author_field = Title_index.CreateField("Book Author")
    Set Bk_number = Title_index.CreateField("Book number")
    Title_index.Fields.Append Title_field
    Title_index.Fields.Append Author_field
    Title_index.Fields.Append Bk_number
    Books_table.Indexes.Append Title_index
     
    Set Registered_on_index = Books_table.CreateIndex("Registered on index")
    Set Date_reg = Registered_on_index.CreateField("Date registered")
    Set Bk_number = Registered_on_index.CreateField("Book number")
    Registered_on_index.Fields.Append Date_reg
    Registered_on_index.Fields.Append Bk_number
    Books_table.Indexes.Append Registered_on_index
    
    Set Dewey_index = Books_table.CreateIndex("Dewey index")
    Set Dewey_field = Dewey_index.CreateField("Dewey")
    Set Bk_number = Dewey_index.CreateField("Book number")
    Dewey_index.Fields.Append Dewey_field
    Dewey_index.Fields.Append Bk_number
    Books_table.Indexes.Append Dewey_index
    
    Set Class_index = Books_table.CreateIndex("Class index")
    Set Class_field = Class_index.CreateField("class")
    Set Bk_number = Class_index.CreateField("Book number")
    Class_index.Fields.Append Class_field
    Class_index.Fields.Append Bk_number
    Books_table.Indexes.Append Class_index
    
    Set Deregistered_on_index = Books_table.CreateIndex("Deregistered on index")
    Set Deregistered = Deregistered_on_index.CreateField("Deregistered")
    Set Bk_number = Deregistered_on_index.CreateField("Book number")
    Deregistered_on_index.Fields.Append Deregistered
    Deregistered_on_index.Fields.Append Bk_number
    Books_table.Indexes.Append Deregistered_on_index
        
    Set Reason_index = Books_table.CreateIndex("reason index")
    Set Reason = Reason_index.CreateField("Reason")
    Set Bk_number = Reason_index.CreateField("Book number")
    Reason_index.Fields.Append Reason
    Reason_index.Fields.Append Bk_number
    Books_table.Indexes.Append Reason_index
    
    
    
End Sub

Public Sub Create_books_borrowed_table()
    Set Borrowed_books_table = Libra.CreateTableDef("Books borrowed table")
    Set SubscriberID = Borrowed_books_table.CreateField("Subscriber ID", dbText, 8)
    Set Bk_number = Borrowed_books_table.CreateField("Book number", dbLong)
    Set Date_borrowed = Borrowed_books_table.CreateField("Date borrowed", dbDate)
    Set Date_due = Borrowed_books_table.CreateField("Date due", dbDate)
    
    Borrowed_books_table.Fields.Append SubscriberID
    Borrowed_books_table.Fields.Append Bk_number
    Borrowed_books_table.Fields.Append Date_borrowed
    Borrowed_books_table.Fields.Append Date_due

    Libra.TableDefs.Append Borrowed_books_table
    
    
    Set SubscriberID_index = Borrowed_books_table.CreateIndex _
                                            ("Subscriber id index")
    Set SubscriberID = SubscriberID_index.CreateField("Subscriber ID")
    
    Set Book_number_index = Borrowed_books_table.CreateIndex _
                                            ("Book number index")
    Set Bk_number = Book_number_index.CreateField("Book number")
    
    SubscriberID_index.Fields.Append SubscriberID
    Book_number_index.Fields.Append Bk_number
    
    Borrowed_books_table.Indexes.Append SubscriberID_index
    Borrowed_books_table.Indexes.Append Book_number_index
    
    
End Sub

Public Sub Create_books_requested_table()
    Set Requested_books_table = Libra.CreateTableDef("Books requested table")
    Set SubscriberID = Requested_books_table.CreateField("Subscriber ID", dbText, 8)
    Set Bk_number = Requested_books_table.CreateField("Book number", dbLong)
    Set Date_requested = Requested_books_table.CreateField("Date requested", dbDate)
    Set Date_due = Requested_books_table.CreateField("expiry date", dbDate)
    
    Requested_books_table.Fields.Append SubscriberID
    Requested_books_table.Fields.Append Bk_number
    Requested_books_table.Fields.Append Date_requested
    Requested_books_table.Fields.Append Date_due

    Libra.TableDefs.Append Requested_books_table
    
    
    Set SubscriberID_index = Requested_books_table.CreateIndex _
                                            ("Subscriber id index")
    Set SubscriberID = SubscriberID_index.CreateField("Subscriber ID")
    
    Set Book_number_index = Requested_books_table.CreateIndex _
                                            ("Book number index")
    Set Bk_number = Book_number_index.CreateField("Book number")
    
    SubscriberID_index.Fields.Append SubscriberID
    Book_number_index.Fields.Append Bk_number
    
    Requested_books_table.Indexes.Append SubscriberID_index
    Requested_books_table.Indexes.Append Book_number_index
    
End Sub

Public Sub Create_setup_table()
    
    Set Setup_table = Libra.CreateTableDef("setup table")
    Set Identifier = Setup_table.CreateField("Identifier", dbText, 30)
    Set Variable = Setup_table.CreateField("Variable", dbText, 33)
    
    Setup_table.Fields.Append Identifier
    Setup_table.Fields.Append Variable
    
    Libra.TableDefs.Append Setup_table
    
    Set Setup_index = Setup_table.CreateIndex("Setup index")
    Set Identifier = Setup_index.CreateField("identifier")
    
    Setup_index.Fields.Append Identifier
    Setup_table.Indexes.Append Setup_index
    
    
End Sub

Public Sub Create_transaction_logs(Transaction_db_path As String)

    On Local Error GoTo error_solver
    Set MyWorkspace = DBEngine.Workspaces(0)
    
    If Dir(Transaction_db_path) <> "" Then
        Kill Transaction_db_path
    End If
    
    Set Transaction_db = MyWorkspace.CreateDatabase _
                (Transaction_db_path, dbLangGeneral, dbEncrypt)
    
    Create_main_log
    Create_Books_log_table
    Create_subscriber_log_table
    Create_user_log_table
    
    Set Main_query = Transaction_db.CreateQueryDef("Main query")
    Set Book_query = Transaction_db.CreateQueryDef("Book query")
    Set Subscriber_query = Transaction_db.CreateQueryDef("Subscriber query")
    Set Security_query = Transaction_db.CreateQueryDef("Security Query")
    Set Query = Transaction_db.CreateQueryDef("Direct SQL Query")
    Set Query = Transaction_db.CreateQueryDef("Report Query Object")
    On Local Error GoTo 0
    
Exit Sub

error_solver:
        If Err.Number = 3204 Then
            Kill Get_ini_data("transac_db_path")
        Else
            Err.Raise Err.Number
        End If
    Resume
    
End Sub

Public Sub Create_main_log()
    
    Set Main_log_table = Transaction_db.CreateTableDef("Main log")
    Set DateField = Main_log_table.CreateField("Date", dbDate)
    Set SubscriberID = Main_log_table.CreateField("Subscriber id", dbText, 8)
    Set TypeField = Main_log_table.CreateField("Type", dbInteger)
    Set Bk_number = Main_log_table.CreateField("Book number", dbLong)
    Set Amount_field = Main_log_table.CreateField("Amount", dbCurrency)
    Set Extra_date = Main_log_table.CreateField("Extra date", dbDate)
    
    Main_log_table.Fields.Append DateField
    Main_log_table.Fields.Append SubscriberID
    Main_log_table.Fields.Append TypeField
    Main_log_table.Fields.Append Bk_number
    Main_log_table.Fields.Append Amount_field
    Main_log_table.Fields.Append Extra_date
    
    Set Date_index = Main_log_table.CreateIndex("Main log index")
    Set DateField = Date_index.CreateField("date")
    
    Date_index.Fields.Append DateField
    Main_log_table.Indexes.Append Date_index
    
    Transaction_db.TableDefs.Append Main_log_table
    
    
End Sub

Public Sub Create_Books_log_table()

    Set Books_log_table = Transaction_db.CreateTableDef("Books Log")
    
    Set DateField = Books_log_table.CreateField("Date", dbDate)
    Set TypeField = Books_log_table.CreateField("Type", dbInteger)
    Set Bk_number = Books_log_table.CreateField("Book Number", dbLong)
    Set Date_reg = Books_log_table.CreateField("Date registered", dbDate)
    Set Title_field = Books_log_table.CreateField("Book Title", dbText, 25)
    Set Author_field = Books_log_table.CreateField("Book author", dbText, 20)
    Set Borrowing_fee = Books_log_table.CreateField("Borrowing fee", dbInteger)
    Set Loan_period = Books_log_table.CreateField("Loan period", dbText, 6)
    Set Loanable = Books_log_table.CreateField("Loanable", dbBoolean)
    Set Publisher_field = Books_log_table.CreateField("Publisher", dbText, 25)
    Set Supplier_field = Books_log_table.CreateField("Supplier", dbText, 20)
    Set Dewey_field = Books_log_table.CreateField("Dewey", dbText, 15)
    Set Class_field = Books_log_table.CreateField("Class", dbText, 10)
    Set ISBN_field = Books_log_table.CreateField("ISBN", dbText, 20)
    Set Reason = Books_log_table.CreateField("Reason", dbText, 30)
    Set Remark_field = Books_log_table.CreateField("Remark", dbText, 30)
    Set Edited_fields = Books_log_table.CreateField("Edited", dbText, 12)
    
    
    Books_log_table.Fields.Append DateField
    Books_log_table.Fields.Append TypeField
    Books_log_table.Fields.Append Bk_number
    Books_log_table.Fields.Append Date_reg
    Books_log_table.Fields.Append Title_field
    Books_log_table.Fields.Append Author_field
    Books_log_table.Fields.Append Borrowing_fee
    Books_log_table.Fields.Append Loan_period
    Books_log_table.Fields.Append Loanable
    Books_log_table.Fields.Append Publisher_field
    Books_log_table.Fields.Append Supplier_field
    Books_log_table.Fields.Append Dewey_field
    Books_log_table.Fields.Append Class_field
    Books_log_table.Fields.Append ISBN_field
    Books_log_table.Fields.Append Reason
    Books_log_table.Fields.Append Remark_field
    Books_log_table.Fields.Append Edited_fields
    
    Set Date_index = Books_log_table.CreateIndex("Books log index")
    Set DateField = Date_index.CreateField("date")
    
    Date_index.Fields.Append DateField
    Books_log_table.Indexes.Append Date_index
    
    
    Transaction_db.TableDefs.Append Books_log_table
    
    
End Sub

Public Sub Create_subscriber_log_table()

    Set Subscriber_log_table = Transaction_db.CreateTableDef("Subscriber log")
        
    Set DateField = Subscriber_log_table.CreateField("Date", dbDate)
    Set TypeField = Subscriber_log_table.CreateField("Type", dbInteger)
    Set SubscriberID = Subscriber_log_table.CreateField("Subscriber ID", dbText, 8)
    Set National_ID = Subscriber_log_table.CreateField("National ID", dbText, 20)
    Set Date_reg = Subscriber_log_table.CreateField("Registered on", dbDate)
    Set Surname = Subscriber_log_table.CreateField("Surname", dbText, 15)
    Set Initials = Subscriber_log_table.CreateField("Initials", dbText, 3)
    Set Home_address = Subscriber_log_table.CreateField("Home address", dbText, 60)
    Set Home_phone_no = Subscriber_log_table.CreateField("Home Phone Number", dbText, 12)
    Set Contact_address = Subscriber_log_table.CreateField("Contact Address", dbText, 60)
    Set Contact_phone_no = Subscriber_log_table.CreateField("Contact Phone Number", dbText, 12)
    Set Expiry_date = Subscriber_log_table.CreateField("Expiry date", dbDate)
    Set Borrowing_limit = Subscriber_log_table.CreateField("Borrowing limit", dbInteger)
    Set Title_field = Subscriber_log_table.CreateField("Subscriber title", dbText, 4)
    Set Borrowing_fee = Subscriber_log_table.CreateField("Borrowing Fee", dbInteger)
    Set Loan_period = Subscriber_log_table.CreateField("Loan Period", dbText, 4)
    Set Reason = Subscriber_log_table.CreateField("Reason", dbText, 30)
    Set Remark_field = Subscriber_log_table.CreateField("Remark", dbText, 30)
    Set Edited_fields = Subscriber_log_table.CreateField("Edited", dbText, 14)
    
    
    Subscriber_log_table.Fields.Append DateField
    Subscriber_log_table.Fields.Append TypeField
    Subscriber_log_table.Fields.Append SubscriberID
    Subscriber_log_table.Fields.Append National_ID
    Subscriber_log_table.Fields.Append Date_reg
    Subscriber_log_table.Fields.Append Surname
    Subscriber_log_table.Fields.Append Initials
    Subscriber_log_table.Fields.Append Home_address
    Subscriber_log_table.Fields.Append Home_phone_no
    Subscriber_log_table.Fields.Append Contact_address
    Subscriber_log_table.Fields.Append Contact_phone_no
    Subscriber_log_table.Fields.Append Expiry_date
    Subscriber_log_table.Fields.Append Borrowing_limit
    Subscriber_log_table.Fields.Append Title_field
    Subscriber_log_table.Fields.Append Borrowing_fee
    Subscriber_log_table.Fields.Append Loan_period
    Subscriber_log_table.Fields.Append Reason
    Subscriber_log_table.Fields.Append Remark_field
    Subscriber_log_table.Fields.Append Edited_fields
    
    Set Date_index = Subscriber_log_table.CreateIndex("subscriber log index")
    Set DateField = Date_index.CreateField("date")
    
    Date_index.Fields.Append DateField
    Subscriber_log_table.Indexes.Append Date_index
    
    Transaction_db.TableDefs.Append Subscriber_log_table
    
End Sub

Public Sub Initialise_recordsets()
    
    Set Books = Libra.OpenRecordset("Books table", dbOpenTable)
    Set Deregistered_Books = Libra.OpenRecordset("Deregistered books", dbOpenTable)
    Set Subscribers = Libra.OpenRecordset("subscriber table", dbOpenTable)
    Set Terminated_subscriptions = Libra.OpenRecordset("Terminated subscriptions table", dbOpenTable)
    Set Setup = Libra.OpenRecordset("setup table", dbOpenTable)
    Set Borrowed_books = Libra.OpenRecordset("books borrowed table", dbOpenTable)
    Set Requested_books = Libra.OpenRecordset("books requested table", dbOpenTable)
    Set Query = Libra.QueryDefs("query obj")
    
    Set Main_log = Transaction_db.OpenRecordset("Main log")
    Set Books_log = Transaction_db.OpenRecordset("Books log")
    Set Subscriber_log = Transaction_db.OpenRecordset("Subscriber log")
    Set User_log = Transaction_db.OpenRecordset("User's log")
    
End Sub


Public Sub Create_user_log_table()

    Set User_log_table = Transaction_db.CreateTableDef("User's log")
    
    Set Time_in = User_log_table.CreateField("Time in", dbDate)
    Set User_name_field = User_log_table.CreateField("User name", dbText, 30)
    Set Time_out = User_log_table.CreateField("Time out", dbDate)
    Set TypeField = User_log_table.CreateField("Area", dbInteger)
    Set SessionID_fld = User_log_table.CreateField("Session", dbLong)
    
    Time_out.Required = False
    SessionID_fld.Attributes = dbAutoIncrField
    
    
    User_log_table.Fields.Append Time_in
    User_log_table.Fields.Append User_name_field
    User_log_table.Fields.Append Time_out
    User_log_table.Fields.Append TypeField
    User_log_table.Fields.Append SessionID_fld
    
    Set User_log_index = User_log_table.CreateIndex("User log index")
    Set Session_ID = User_log_index.CreateField("Session")
    
    User_log_index.Fields.Append Session_ID
    User_log_table.Indexes.Append User_log_index
    
    Transaction_db.TableDefs.Append User_log_table
    
End Sub

Public Sub Initialise_setup_table()
    Dim Temp As String
           
    
    Set Host_form = Screen.ActiveForm
    
    Temp = Host_form.txtSubscriberID.Text
    Call Register_setup_data("subscriber id format", Temp)
    Temp = Host_form.txtLicensed_to.Text
    Call Register_setup_data("Licensed to", Temp)
    Call Register_setup_data("date", "12113")
    
    'limits collection
    Call Register_setup_data("borrowing limit as to", "1")
    Call Register_setup_data("fixed borrowing limit", "0")
    Call Register_setup_data("request limit as to", "1")
    Call Register_setup_data("fixed requisition limit", "0")
    Call Register_setup_data("loan duration as to", "1")
    Call Register_setup_data("fixed loan duration", "0000")
    Call Register_setup_data("request valid for", "0000")
    
    'Charges collection
    Call Register_setup_data("books charged as to", "1")
    Call Register_setup_data("fixed book charge", "0")
    Call Register_setup_data("fine per day", "0")
    
    'Users collection
    Temp = Host_form.txtName.Text
    Call Register_setup_data("User 1 name", Temp)
    
    Temp = Host_form.txtPassword.Text
    Call Register_setup_data("User 1 password", Temp)
       
    
    Call Register_setup_data("User 2 name", "")
    Call Register_setup_data("User 2 password", "")
    Call Register_setup_data("User 3 name", "")
    Call Register_setup_data("User 3 password", "")
    
    'Startup collection
    Call Register_setup_data("Summary stats", "1")
    Call Register_setup_data("Confirm date", "1")
    
End Sub
